# Site Options

This folder contains the main logic and style code for the Moxy Site Options & Live Customizer app. You can find the shared code in `root/modules` and client frontend code in `root/client` folder.

## Core Sections

* `/script`: contains the main javascript logic code of the app. Some shared modules are imported from `root/modules/script`.
* `/sass`: contains the main stylesheet code of the app. Some shared modules are imported from `root/modules/scss`.
* `/panels`: contains the APIs and the code for adding custom fields and tabs.

## Main Modules

* `MoxyOptions.php`: add backend menu and toolbar and enqueue frontend script.
* `MoxyBackendOptions.php`: mainly used to embed scripts for the Site Options app.
* `MoxyFrontendOptions.php`: mainly used to embed scripts for the Live Customizer app.
* `MoxyOptionsAPI.php`: register the request endpoints based on WordPress RESTful APIs.
* `initial_data.json`: contains the default data after installing the plugin.
