<?php
$manager = MoxyOptionsManager::getInstance();

$manager::addPanel("third_party", array(
    "side" => "backend",
    "icon" => "key",
    "name" => "Third Party Keys"
));

$manager::addChildPanel("instagram_setting", "third_party", array(
    "name" => "Instagram",
    "models" => [
        array(
            "tag" => "editor-container",
            "attrs" => array(
                "label" => "Instagram",
                "collapsed" => false
            ),
            "content" => [
                array(
                    "tag" => "editor-field",
                    "attrs" => array(
                        "type" => "desc",
                        "fullwidth" => "true",
                        "config" => array(
                            "message" => "Enter your Instagram API keys into the below fields. All Instagram Widgets from the theme scope used to add Instagram photos to your site will be based on these keys. <a href=http://docs.moxypress.com/moxy/site-options/#instagram target=_blank>Instagram Keys Documentation</a>"
                        )
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "instagram_access_token",
                    "attrs" => array(
                        "label" => "Access Token",
                        "type" => "text",
                        "desc" => "This token is required by authenticated request."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "instagram_username",
                    "attrs" => array(
                        "label" => "Username",
                        "type" => "text",
                        "desc" => "Specify your Instagram username."
                    ),
                    "default_value" => ""
                )
            ]
        )
    ]
));

$manager::addChildPanel("twitter_setting", "third_party", array(
    "name" => "Twitter",
    "models" => [
        array(
            "tag" => "editor-container",
            "attrs" => array(
                "label" => "Twitter",
                "collapsed" => false
            ),
            "content" => [
                array(
                    "tag" => "editor-field",
                    "attrs" => array(
                        "type" => "desc",
                        "fullwidth" => "true",
                        "config" => array(
                            "message" => "Enter your Twitter API keys into the below fields. All Twitter Widgets from the theme scope used to display your Twitter feed into this site will be based on these keys. <a href=http://docs.moxypress.com/moxy/site-options/#twitter target=_blank>Twitter Keys Documentation</a>"
                        )
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "twitter_username",
                    "attrs" => array(
                        "label" => "Username",
                        "type" => "text",
                        "desc" => "Specify your Twitters username."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "twitter_consumer_key",
                    "attrs" => array(
                        "label" => "Consumer Key",
                        "type" => "text",
                        "desc" => "Specify your consumer key (API key)."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "twitter_consumer_secret",
                    "attrs" => array(
                        "label" => "Consumer Secret",
                        "type" => "text",
                        "desc" => "Specify your consumer secret (API secret)."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "twitter_access_token",
                    "attrs" => array(
                        "label" => "Access Token",
                        "type" => "text",
                        "desc" => "This token is used to make API requests on your own accounts behalf."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "twitter_access_token_secret",
                    "attrs" => array(
                        "label" => "Access Token Secret",
                        "type" => "text",
                        "desc" => "Specify your access token secret."
                    ),
                    "default_value" => ""
                )
            ]
        )
    ]
));

$manager::addChildPanel("flickr_setting", "third_party", array(
    "name" => "Flickr",
    "models" => [
        array(
            "tag" => "editor-container",
            "attrs" => array(
                "label" => "Flickr",
                "collapsed" => false
            ),
            "content" => [
                array(
                    "tag" => "editor-field",
                    "attrs" => array(
                        "type" => "desc",
                        "fullwidth" => "true",
                        "config" => array(
                            "message" => "Enter your Flickr API keys into the below fields. All Flickr Widgets from the theme scope used to add Flickr photos to your site will be based on these keys. <a href=http://docs.moxypress.com/moxy/site-options/#flickr target=_blank>Flickr Keys Documentation</a>"
                        )
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "flickr_api_key",
                    "attrs" => array(
                        "label" => "API Key",
                        "type" => "text",
                        "desc" => "This key is used to track API usage (commercial or non-commercial)."
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "flickr_user_id",
                    "attrs" => array(
                        "label" => "User ID",
                        "type" => "text",
                        "desc" => "Specify your Flickrs User ID"
                    ),
                    "default_value" => ""
                )
            ]
        )
    ]
));

$manager::addChildPanel("google_map_setting", "third_party", array(
    "name" => "Google Map",
    "models" => [
        array(
            "tag" => "editor-container",
            "attrs" => array(
                "label" => "Google Map",
                "collapsed" => false
            ),
            "content" => [
                array(
                    "tag" => "editor-field",
                    "attrs" => array(
                        "type" => "desc",
                        "fullwidth" => "true",
                        "config" => array(
                            "message" => "Enter your Google Map API key. All Map Widgets from the theme scope used to display Google maps on your site will be based on the key. <a href=http://docs.moxypress.com/moxy/site-options/#google-map target=_blank>Google Map Documentation</a>"
                        )
                    ),
                    "default_value" => ""
                ),
                array(
                    "tag" => "editor-field",
                    "bind_to" => "google_map_api_key",
                    "attrs" => array(
                        "label" => "API Key",
                        "type" => "text",
                        "desc" => "This API key allows you to monitor your applications API usage in the Google API Console"
                    ),
                    "default_value" => ""
                )
            ]
        )
    ]
));
?>
