<?php

class MoxyPageLayout{
	function __construct(array $options)
	{
		$this->options = $options;

		if(!empty($this->options['content_class'])){
			$this->options['content_class'] = ' '.$this->options['content_class'];
		}else{
			$this->options['content_class'] = '';
		}

		if(!empty($this->options['wrap_class'])){
			$this->options['wrap_class'] = ' '.$this->options['wrap_class'];
		}else{
			$this->options['wrap_class'] = '';
		}

		if(empty($this->options['has_border'])){
			$this->options['has_border'] = false;
		}

	}

	public function render(){
		switch ($this->options['type']) {
			case 'fullwidth':
				$this->fullwidth_render();
				break;
			case 'sidebar-left':
				$this->sidebar_left_render();
				break;
			case 'sidebar-right':
				$this->sidebar_right_render();
				break;
			default:
				$this->blank_render();
				break;
		}
	}

	protected function blank_render(){
		echo '<div class="moxy-page'.$this->options['content_class'].'">'.$this->options['content'].'</div>';
	}

	protected function fullwidth_render(){
		?>
		<div class="moxy-page moxy-page--fullwidth <?php echo $this->options['wrap_class']; ?>">
			<div class="moxy-container">
				<div class="moxy-row">
					<div class="moxy-page__content moxy-page__column<?php echo $this->options['content_class']; ?>">
						<?php echo $this->options['content']; ?>
					</div>
				</div>
			</div>
		</div>
		<?php
	}

	protected function sidebar_left_render(){
		?>
		<div class="moxy-page moxy-page--sidebarLeft moxy-page--singleSidebar moxy-page--hasSidebar<?php echo $this->options['wrap_class']; ?> <?php if ($this->options['has_border']) echo 'moxy-page--hasBorder' ?>">
			<div class="moxy-container">
				<div class="moxy-row">
					<div class="moxy-page__content moxy-page__column">
						<div class="moxy-page__content--paddingLeft<?php echo $this->options['content_class']; ?>"><?php echo $this->options['content']; ?></div>
					</div>
					<div class="moxy-page__sidebar moxy-page__column">
						<?php if (!empty($this->options['sidebar']) && is_active_sidebar('moxy-sidebar-' . $this->options['sidebar'])): ?>
							<aside class="moxy-page__sidebar--paddingRight"><?php dynamic_sidebar('moxy-sidebar-' . $this->options['sidebar']); ?></aside>
						<?php endif; ?>
					</div>
				</div>
			</div>
		</div>
		<?php
	}

	protected function sidebar_right_render(){
		?>
		<div class="moxy-page moxy-page--sidebarRight moxy-page--singleSidebar moxy-page--hasSidebar<?php echo $this->options['wrap_class']; ?> <?php if ($this->options['has_border']) echo 'moxy-page--hasBorder' ?>">
			<div class="moxy-container">
				<div class="moxy-row">
					<div class="moxy-page__content moxy-page__column">
						<div class="moxy-page__content--paddingRight<?php echo $this->options['content_class']; ?>"><?php echo $this->options['content']; ?></div>
					</div>
					<div class="moxy-page__sidebar moxy-page__column">
						<?php if (!empty($this->options['sidebar']) && is_active_sidebar('moxy-sidebar-' . $this->options['sidebar'])): ?>
							<aside class="moxy-page__sidebar--paddingLeft"><?php dynamic_sidebar('moxy-sidebar-' . $this->options['sidebar']); ?></aside>
						<?php endif; ?>
					</div>
				</div>
			</div>
		</div>
		<?php
	}
}