<?php
$options = moxy_fw_get_options();

function moxy_fw_single_post_info_render($author_id) {
	?>
	<header class="moxy-singlePost__header">
		<div class="moxy-singlePost__avatar-wrap">
			<?php
			$href = get_author_posts_url($author_id);
			$url = get_avatar_url($author_id);
			echo moxy_fw_get_avatar($href, $url, ['moxy-singlePost__avatar']);
			?>
		</div>
		<div class="moxy-singlePost__info">
			<a href="<?php echo get_author_posts_url($author_id); ?>" class="moxy-singlePost__author lc-p moxy--mBold"><?php the_author(); ?></a>
			<div class="moxy-singlePost__date lc-d"><?php echo _e('on', 'moxy') ?> <?php the_date('M d, Y'); ?></div>
		</div>
	</header>
	<?php
}

function moxy_fw_single_post_hero_render($options, $author_id) {
	?>
	<div class="moxy-singlePost__hero<?php if(!empty($options['single_post_hero_parallax'])) echo ' moxy-singlePost__hero--parallax';?>">
		<?php
		if(has_post_thumbnail()):
		?>
		<div class="moxy-hero__background">
			<?php echo moxy_fw_get_post_feature_lazy_image(); ?>
		</div>
		<?php
		endif;
		?>

		<div class="moxy-singlePost__hero__overlay"></div>
		<div class="moxy-singlePost__hero__content">
			<div class="moxy-singlePost__hero__content__wrap">
				<div class="moxy-container">
					<div class="moxy-singlePost__hero__cats moxy--bold"><?php echo moxy_fw_get_category_list_html(get_the_category()); ?></div>
					<h1 class="moxy-singlePost__hero__title"><?php the_title(); ?></h1>
					<div class="moxy-singlePost__hero__info">
						<?php
						$href = get_author_posts_url($author_id);
						$url = get_avatar_url($author_id);
						echo moxy_fw_get_avatar($href, $url, ['moxy-singlePost__hero__avatar']);
						?>
						<div class="moxy-singlePost__hero__author moxy--marginTop5"><a href="<?php echo get_author_posts_url($author_id); ?>" class="moxy--eBold"><?php the_author(); ?></a></div>
						<div class="moxy-singlePost__hero__date"><?php _e('on','moxy') ?> <?php the_date('M d, Y'); ?></a></div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<?php
}

function moxy_fw_single_post_tags_render() {
	$tags = get_the_tags();

	if (!empty($tags)):
		$tags_html = array();

		foreach ($tags as $tag) {
			$tags_html[] = '<a href="' . get_tag_link($tag->term_id) . '" class="moxy-singlePost__tag moxy-link">' . $tag->name . '</a>';
		}
		?>
		<div class="moxy-singlePost__tags">
			<?php echo implode('', $tags_html); ?>
		</div><!-- post tags -->
	<?php endif;
}

function moxy_fw_single_post_share_render($options) {
	?>
	<div class="moxy-singlePost__share">
		<span><?php _e('Share', 'moxy')?>:</span>
		<?php

		if(!empty($options['single_twitter_enable'])){
			echo '<a class="moxy-singlePost__share__twitter" target="_blank" href="http://twitter.com/share?text='.get_the_title().'&url='.get_the_permalink().'"><span class="fa fa-twitter"></a>';
		}

		if(!empty($options['single_facebook_enable'])){
			echo '<a class="moxy-singlePost__share__facebook" target="_blank" href="https://www.facebook.com/sharer/sharer.php?u='.get_the_permalink().'"><span class="fa fa-facebook"></a>';
		}

		if(!empty($options['single_linkedin_enable'])){
			echo '<a class="moxy-singlePost__share__linkedin" target="_blank" href="https://www.linkedin.com/shareArticle?mini=true&url=' . get_the_permalink() . '&source=LinkedIn">
						<span class="fa fa-linkedin"></span>
					</a>';
		}

		if(!empty($options['single_pinterest_enable']) && has_post_thumbnail()){
			echo '<a class="moxy-singlePost__share__pinterest" href="http://pinterest.com/pin/create/button/?url=' . get_the_permalink() . '&media=' . get_the_post_thumbnail_url() . '&description=' . get_the_title() . '" count-layout="horizontal" target="_blank">
						<span class="fa fa-pinterest"></span>
					</a>';
		}

		if(!empty($options['single_email_enable'])){
			echo '<a class="moxy-singlePost__share__email" href="mailto:" target="_blank"><span class="fa fa-envelope"></span></a>';
		}
		?>
	</div>
	<?php
}

function moxy_fw_single_post_author_summary_render($author_id, $options) {
	?>
	<div class="moxy-authorSummary lc-b">
		<div class="moxy-media moxy-media--top">
			<div class="moxy-media__image">
				<?php
				$url = get_avatar_url($author_id);
				echo moxy_fw_get_avatar('', $url, ['moxy-authorSummary__avatar']);
				?>
			</div>
			<div class="moxy-media__content moxy-authorSummary__detail">
				<h6 class="moxy-authorSummary__name lc-h moxy--eBold"><?php the_author(); ?></h6>
				<p class="moxy-authorSummary__bio">
					<?php echo get_user_meta($author_id, 'description', true); ?>
				</p>
				<a href="<?php echo get_author_posts_url($author_id); ?>" class="moxy-authorSummary__visitLink lc-h-p moxy--eBold"><?php _e("All author posts", 'moxy'); ?> »</a>
			</div>
		</div>
	</div><!-- single post author summary -->
	<?php
}

function moxy_fw_single_post_nav_render() {
	$previous_post = get_previous_post();
	$next_post = get_next_post();
	if(!empty($previous_post) || !empty($next_post)):
	?>
		<div class="moxy-postNav lc-b lcs-d-h">
			<?php
			if (!empty($previous_post)) :
				?>
				<div class="moxy--floatLeft">
					<a href="<?php echo get_permalink($previous_post->ID); ?>">« <?php _e('Previous post','moxy') ?></a>
				</div>
				<?php
			endif;

			if (!empty($next_post)) :
				?>
				<div class="moxy--floatRight">
					<a href="<?php echo get_permalink($next_post->ID); ?>"><?php _e('Next post','moxy'); ?> »</a>
				</div>
				<?php
			endif;
			?>
		</div><!-- single post navigation -->
	<?php
	endif;
}

function moxy_fw_load_more_button_render($args = array(), $echo = true) {
	$args = array_merge(array(
		'settings' => array(
			'limit' => 5,
			'orderby' => 'date',
			'order' => 'DESC',
			'data' => json_encode(array('type' => 'posts')),
			'append_to' => '.moxy-blogImage__wrap',
			'text' => __('Load More','moxy'),
			'loading_text' => __('Loading...','moxy')
		),
		'custom_settings' => array(),
		'custom_class' => '',
		'before' => '',
		'after' => ''
	), $args);

	$custom_settings = !empty($args['custom_settings']) ? ' data-custom-settings="' . esc_attr(json_encode($args['custom_settings'])) . '"' : '';

	ob_start(); ?>
	<?php echo $args['before']; ?>
	<div class="moxy-loadMoreBtn__wrap">
		<button class="moxy-loadMoreBtn moxy--eBold<?php echo !empty($args['custom_class']) ? ' '.$args['custom_class'] : ''; ?>"
				data-settings="<?php echo esc_attr(json_encode($args['settings']));?>"<?php echo $custom_settings; ?>>
			<span class="moxy-loadMoreBtn__icon"></span><span class="moxy-loadMoreBtn__text"><?php echo $args['settings']['text']; ?></span>
		</button>
	</div>
	<?php
	echo $args['after'];
	$html = ob_get_clean();

	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_infinite_scroller_render($args = array(), $echo = true) {
	$args = array_merge(array(
		'settings' => array(
			'limit' => 5,
			'orderby' => 'date',
			'order' => 'DESC',
			'data' => json_encode(array('type' => 'posts')),
			'append_to' => '.moxy-blogImage__wrap',
			'load_all_text' => __('No more posts to load','moxy'),
		),
		'custom_settings' => array(),
		'custom_class' => ''
	), $args);

	$custom_settings = !empty($args['custom_settings']) ? ' data-custom-settings="' . esc_attr(json_encode($args['custom_settings'])) . '"' : '';

	ob_start() ?>
	<div class="moxy-infiniteScroller<?php if(!empty($args['custom_class'])) echo ' '.$args['custom_class']; ?>"
		 data-settings="<?php echo esc_attr(json_encode($args['settings'])); ?>"<?php echo $custom_settings ?>></div>
	<?php
	$html = ob_get_clean();

	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_module_is_enabled($module, $frontend = true) {
	$options = moxy_fw_get_options();

	if(!is_array($options['exclude_modules'])){
		return false;
	}

	if ($frontend) {
		return !in_array($module, $options['exclude_modules']) && !empty($options[$module.'_enable']);
	} else {
		return !in_array($module, $options['exclude_modules']);
	}
}

function moxy_fw_classic_post_item_render($args, $custom_class = array(), $echo = true) {
	global $options;
	$id = get_the_ID();
	$settings = moxy_fw_get_settings($id);
	$short_info = !empty($args['info']);
	$custom_class[] = 'moxy-blogClassic__item lc-b';

	if(!empty($options['blog_classic_scroll_effect']) && $options['blog_classic_scroll_effect'] != 'none'){
		$custom_class[] = 'moxy-sa';
		$custom_class[] = $options['blog_classic_scroll_effect'];
	}

	ob_start();
	?>
	<article <?php post_class(implode(' ', $custom_class)); ?>>
		<div class="moxy-bci__wrap">
			<?php if ($short_info) : ?>
				<div class="moxy-bci__lookup">
					<div class="moxy-bci__avatar-wrap moxy--paddingRight10">
						<?php
						$author_id = get_the_author_meta('ID');
						$href = get_author_posts_url($author_id);
						$url = get_avatar_url($author_id);
						echo moxy_fw_get_avatar($href, $url, ['moxy-bci__avatar']);
						?>
					</div>

					<div class="moxy-bci__info">
						<a href="<?php echo get_author_posts_url($author_id); ?>" class="moxy-bci__author lc-p moxy--bold"><?php the_author(); ?></a>
						<div class="moxy-bci__date lc-d">
							<?php echo get_the_date('M d, Y'); ?>
						</div>
					</div>
				</div><!-- lookup-->
			<?php endif; ?>

			<div class="moxy-bci__content">
				<?php
				if (!empty($settings['feature']['url'])) :
					$urls = !empty($settings['feature']['sizes']) ? $settings['feature']['sizes'] : array();
					?>
					<div class="moxy-bci__media">
						<figure class="moxy-bci__image">
						<?php
						echo moxy_fw_get_lazy_image($settings['feature']['url'], $urls, array('600', '900', '1200', 'full'));
						?>
						</figure>
					</div>
				<?php
				elseif(has_post_thumbnail()):
				?>
					<div class="moxy-bci__media">
						<figure class="moxy-bci__image">
							<?php
							echo moxy_fw_get_post_feature_lazy_image();;
							?>
						</figure>
					</div>
				<?php endif; ?>

				<h3 class="moxy-bci__title lcs-h-p"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
				<?php
				if(has_excerpt()){
					echo '<div class="moxy-bci__excerpt">' . moxy_fw_trim_excerpt(get_the_excerpt(), 30) . '</div>';
				}
				?>
			</div>

			<a class="moxy-bci__readMore lc-d-h" href="<?php the_permalink(); ?>"><?php _e('Read more', 'moxy'); ?>...</a>
		</div>
	</article>
	<?php
	$html = ob_get_clean();

	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_classic_grid_post_item_render($args, $custom_class = array(), $echo = true) {
	$ID = get_the_ID();
	$custom_class[] = 'moxy-bcgi moxy-gCol';

	ob_start();
	?>
	<article <?php post_class(implode(' ', $custom_class)); ?>>
		<div class="moxy-bcgi__wrap">
			<?php
			if (has_post_thumbnail()):
				echo '<a class="moxy-bcgi__img" href="'.get_the_permalink().'">'.moxy_fw_get_post_feature_lazy_image().'</a>';
			endif; ?>
			<div class="moxy-bcgi__content">
				<div class="moxy-bcgi__cats moxy--bold">
					<?php echo moxy_fw_get_category_list_html(get_the_category()); ?>
				</div>
				<h6 class="moxy-bcgi__title"><a href="<?php echo get_the_permalink(); ?>"><?php echo get_the_title(); ?></a></h6>
				<?php if ($args['excerpt_enable'] && has_excerpt($ID)) : ?>
					<div class="moxy-bcgi__excerpt"><?php echo moxy_fw_trim_excerpt(get_the_excerpt($ID), 25); ?></div>
				<?php endif; ?>

				<footer class="moxy-bcgi__footer">
					<?php
					$author_id = get_the_author_meta('ID');
					$href = get_author_posts_url($author_id);
					$url = get_avatar_url($author_id);
					echo moxy_fw_get_avatar($href, $url, ['moxy-bcgi__avatar']);
					?>
					<a href="<?php echo get_author_posts_url($author_id); ?>" class="moxy-bcgi__author moxy--bold"><?php echo get_the_author_meta('display_name', $author_id); ?></a>
				</footer>
			</div>
		</div>
	</article>
	<?php
	$html = ob_get_clean();

	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_search_item_render($custom_class = array(), $echo = true) {
	global $options;


	ob_start(); ?>
	<div class="moxy-search__item">
		<?php
		$post_type = get_post_type();
		$id = get_the_ID();
		if (in_array($post_type, array('post', 'page', 'portfolio'))) :
			$settings = moxy_fw_get_settings($id);

			?>

			<a class="moxy-search__image lc-d" href="<?php the_permalink(); ?>">
			<?php
			if (has_post_thumbnail($id)):
				echo moxy_fw_get_post_feature_lazy_image($id, array('medium'));
			else: ;
				echo '<div class="moxy-search__thumb"></div>';
			endif;
			?>
			</a>
		<?php
		endif;
		?>
		<div class="moxy-search__content lc-b">
			<h6 class="moxy-search__title moxy--eBold lcs-h-p"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h6>
			<?php if (has_excerpt()) : ?>
				<p class="moxy-search__excerpt"><?php echo moxy_fw_trim_excerpt(get_the_excerpt(), 30); ?></p>
			<?php endif; ?>
		</div>
	</div>
	<?php
	$html = ob_get_clean();

	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_thumbnail_generate($size, $url) {
	if (has_post_thumbnail()) {
		the_post_thumbnail($size);
	} else { ?>
		<img src="<?php echo $url; ?>" alt="<?php the_title(); ?>" />
	<?php }
}

function moxy_fw_metro_post_item_render($args, $custom_class, $echo = true) {
	$custom_class[] = 'moxy-blogMetro__item';

	if(!empty($args['scroll_effect']) && $args['scroll_effect'] != 'none'){
		$custom_class[] = 'moxy-sa';
		$custom_class[] = $args['scroll_effect'];
	}

	ob_start(); ?>
	<article <?php post_class(implode(' ', $custom_class)); ?>>
		<a href="<?php echo get_the_permalink(); ?>" class="moxy-bmi__wrap">
			<?php
			if(has_post_thumbnail()):
				echo moxy_fw_get_post_feature_lazy_image();
			endif;?>
			<div class="moxy-bmi__overlay"></div>

			<div class="moxy-bmi__content">
				<header class="moxy-bmi__header">
					<div class="moxy-media moxy-media--top">
						<div class="moxy-media__image moxy--paddingRight10">
							<?php
							$author_id = get_the_author_meta('ID');
							$url = get_avatar_url($author_id);
							echo moxy_fw_get_avatar('', $url, ['moxy-bmi__avatar']);
							?>
						</div>
						<div class="moxy-media__content moxy-bmi__info">
							<div class="moxy-bmi__author moxy--eBold"><?php the_author(); ?></div>
							<div class="moxy-bmi__date"><?php echo get_the_date(); ?></div>
						</div>
					</div>
					<h4 class="moxy-bmi__title"><?php the_title(); ?></h4>
				</header>

				<footer class="moxy-bmi__footer moxy--bold">
					<?php
					$categories = get_the_category();
					foreach ($categories as $category) {
						echo '<span>' . $category->name . '</span>';
					}
					?>
				</footer>
			</div>
		</a>
	</article>
	<?php
	$html = ob_get_clean();
	if ($echo) {
		echo $html;
	} else {
		return $html;
	}
}

function moxy_fw_fullwidth_page_render($content, $content_class = '', $wrap_class = '') {
	?>
	<div class="moxy-page <?php echo $wrap_class; ?>">
		<div class="moxy-container">
			<div class="moxy-row">
				<div class="moxy-page__content moxy-page__column <?php echo $content_class; ?>">
					<?php echo $content; ?>
				</div>
			</div>
		</div>
	</div>
	<?php
}

function moxy_fw_page_render() {
	$ID = get_the_ID();
	$setting = moxy_fw_get_settings($ID);
	$options = moxy_fw_get_options();
	$has_border = !empty($options['page_has_border']);

	if(!empty($setting['addition']['before'])){
		echo do_shortcode($setting['addition']['before']);
	}

	// Render Hero Feature Image
	if(!empty($setting['layout']['feature_image'])){
		moxy_fw_get_page_hero_section($options);
	}

	// Render Page Breadcrumb
	if(!empty($setting['layout']['breadcrumb'])){
		moxy_fw_get_page_breadcrumb();
	}

	// Render Page Content
	$type = !empty($setting['layout']['type']) ? $setting['layout']['type'] : 'blank';
	ob_start();
	the_content();
	$content = ob_get_clean();
	$sidebar = !empty($setting['layout']['sidebar']) ? $setting['layout']['sidebar'] : '';

	$page_content_layout = new MoxyPageLayout(array(
		'sidebar' => $sidebar,
		'type' => $type,
		'content' => $content,
		'content_class' => 'moxy-entry',
		'has_border' => $has_border
	));

	$page_content_layout->render();

	if(!empty($setting['addition']['after'])){
		echo do_shortcode($setting['addition']['after']);
	}
}

function moxy_fw_slideshow_post_render($slide_settings, $post_params){
	$posts = get_posts($post_params);

	ob_start();
	if (!empty($posts)) :
		?>
		<div class="moxy-heroSlider owl-carousel" data-settings="<?php echo esc_attr(json_encode($slide_settings)); ?>">
			<?php foreach ($posts as $post) :
				$lazy_bg = '';
				if(has_post_thumbnail($post->ID)){
					$lazy_bg = moxy_fw_get_post_feature_lazy_image($post->ID, array('full', 'large', 'medium_large'));
				}
				?>
				<div class="moxy-heroSlider__slide">
					<?php echo $lazy_bg; ?>
					<div class="moxy-heroSlider__overlay"></div>
					<div class="moxy-heroSlider__content">
						<div class="moxy-container">
							<div class="moxy-heroSlider__info">
								<?php
								$href = get_author_posts_url($post->post_author);
								$url = get_avatar_url($post->post_author);
								echo moxy_fw_get_avatar($href, $url, ['moxy-heroSlider__avatar']);
								?>
								<div class="moxy-heroSlider__author"><?php echo '<a href="'.$href.'" class="moxy--eBold">'.get_the_author_meta('display_name',$post->post_author).'</a>'; ?></div>
							</div>
							<h3 class="moxy-heroSlider__title"><?php echo get_the_title($post->ID); ?></h3>
							<?php if(has_excerpt($post->ID)) :?>
							<p class="moxy-heroSlider__desc"><?php echo moxy_fw_trim_excerpt(get_the_excerpt($post->ID), 30); ?></p>
							<?php endif; ?>
							<a class="moxy-heroSlider__link moxy--eBold" href="<?php echo get_the_permalink($post->ID); ?>"><?php _e('Read more','moxy') ?></a>
						</div>
					</div>
				</div>
			<?php endforeach; ?>
		</div>
		<?php
	endif;

	return ob_get_clean();
}
